#include<bits/stdc++.h>
using namespace std;

int N,X;
int Q;
int L,R;
int prefiks[32][500'005];

int main(){
    scanf("%d%d",&N,&Q);
    for(int i=1;i<=N;++i){
        scanf("%d",&X);
        for(int b=0;b<32;b++){
            prefiks[b][i]=prefiks[b][i-1]+(X&1);
            X>>=1;
        }
    }
    while(Q--){
        scanf("%d%d",&L,&R);
        for(int b=31;b>=0;b--)
            if(prefiks[b][R]-prefiks[b][L-1]){
                printf("%d\n",prefiks[b][R]-prefiks[b][L-1]);
                break;
            }
    }
    return 0;
}